# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ....model import Interface


class IUnicodeDecoder(Interface):
    """ The IUnicodeDecoder interface defines the interface to be implemented
    by models being decoded by the :class:`~dip.io.codecs.UnicodeCodec` codec.
    """

    def set_unicode(self, model, data):
        """ Set the model data from an Python v3 str object or a Python v2
        unicode object.

        :param model:
            is the model.
        :param data:
            the encoded model data.
        :return:
            the decoded model.  This may be the original model populated from
            the storage location, or it may be a different model (of an
            appropriate type) created from the storage location.
        """
