# Copyright (c) 2009 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .meta_interface import MetaInterface


class Interface(object):
    """ The Interface class is the base class for all
    :term:`interfaces<interface>`.  A class is shown to implement an interface
    by decorating it with :func:`~dip.model.implements`.  An interface cannot
    be instantiated.  If it called with an object argument then either that
    argument is returned if it implements the interface, or an :term:`adapter`
    is returned that adapts the object to the interface.  An exception is
    raised if an appropriate adapter could not be found.
    """

    __metaclass__ = MetaInterface
