# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ...ui import ISingleViewContainer

from .single_view_container_adapter import SingleViewContainerAdapter
from .utils import as_QLayout, from_QLayout


class SingleQLayoutContainerAdapter(SingleViewContainerAdapter):
    """ The SingleQLayoutContainerAdapter class is a base class for adapters
    than implement the :class:`~dip.pui.ISingleViewContainer` interface and
    where the contained view is a :class:`~PyQt4.QtGui.QLayout`.
    """

    @ISingleViewContainer.view.getter
    def view(self):
        """ Invoked to get the contained view. """

        return from_QLayout(self.adaptee.layout())

    @view.setter
    def view(self, value):
        """ Invoked to set the contained view. """

        if value is not None:
            self.adaptee.setLayout(as_QLayout(value))
