# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QBoxLayout, QButtonGroup


class DipRadioButtons(QBoxLayout):
    """ The DipRadioButtons class implements a set of radio buttons. """

    def __init__(self, parent=None):
        """ Initialise the editor.

        :param parent:
            is the optional parent widget.
        :return:
            the editor.
        """

        super(DipRadioButtons, self).__init__(QBoxLayout.TopToBottom, parent)

        self.setContentsMargins(0, 0, 0, 0)

        # Make sure the buttons are together.
        self.addStretch()

        # We need a button group in case there are other radio buttons with the
        # same parent.
        QButtonGroup(self)
