# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Instance, List, Tuple

from .i_action import IAction
from .i_action_collection import IActionCollection
from .i_view import IView


class IContainer(IView):
    """ The IContainer interface defines the API to be implemented (typically
    using adaptation) by a :term:`view` that can contain a number of sub-views.
    """

    # The list of actions.
    actions = List(Instance(IAction, IActionCollection))

    # The contained sub-views.
    views = Tuple(IView)
