import sys

from PyQt4.QtGui import QApplication, QFormLayout, QLineEdit, QSpinBox, QWidget

from dip.ui import Bindings


# Every PyQt GUI application needs a QApplication.
app = QApplication(sys.argv)

# Create the model.
model = dict(name='', age=0)

# Create the view programmatically.
layout = QFormLayout()
layout.addRow("Name", QLineEdit(objectName='name_editor'))
layout.addRow("Age", QSpinBox(objectName='age_editor'))

ui = QWidget()
ui.setLayout(layout)

# Define the bindings.
bindings = Bindings(name_editor='name', age_editor='age')

# Bind the view to the model.
bindings.bind(ui, model)

# Make the instance of the view visible.
ui.show()

# Enter the event loop.
app.exec_()

# Show the value of the model.
print("Name:", model['name'])
print("Age:", model['age'])
