# Copyright (c) 2011 Riverbank Computing Limited.


if __name__ == '__main__':
    import sys
    from PyQt4.QtGui import QApplication

    app = QApplication(sys.argv)


try:
    import unittest2 as unittest
except ImportError:
    import unittest

from dip.automate import Robot
from dip.ui import TabBar, TabPage


class TestTabBar(unittest.TestCase):
    """ This tests the TabBar view. """

    def test_visible_page(self):
        """ Test updating a visible page. """

        model = dict(page1="One", page2="Two")
        view = TabBar(TabPage('page1', title="Page 1"),
                TabPage('page2', title="Page 2"), id='TabBar.visible')
        ui = view(model=model)
        ui.show()

        Robot.simulate('TabBar.visible:page1', 'set', "1")
        self.assertEqual(model['page1'], '1')

    def test_hidden_page(self):
        """ Test updating a hidden page. """

        model = dict(page1="One", page2="Two")
        view = TabBar(TabPage('page1', title="Page 1"),
                TabPage('page2', title="Page 2"), id='TabBar.hidden')
        ui = view(model=model)
        ui.show()

        Robot.simulate('TabBar.hidden', 'select', 1)
        Robot.simulate('TabBar.hidden:page2', 'set', "2")
        self.assertEqual(model['page2'], '2')


if __name__ == '__main__':
    unittest.main()
