# Copyright (c) 2011 Riverbank Computing Limited.


if __name__ == '__main__':
    import sys
    from PyQt4.QtGui import QApplication

    app = QApplication(sys.argv)


try:
    import unittest2 as unittest
except ImportError:
    import unittest

from PyQt4.QtGui import QDialog, QWizard

from dip.automate import Robot
from dip.model import Model
from dip.ui import HBox, Wizard, WizardPage


class TestWizard(unittest.TestCase):
    """ This tests the Wizard view. """

    def test_finish(self):
        """ Test Wizard Finish button. """

        model = Model()
        view = Wizard(WizardPage(HBox()), id='Wizard.finish')
        ui = view(model=model)

        robot = Robot()
        robot.record('Wizard.finish', 'click', QWizard.FinishButton)
        robot.play(after=0)

        rc = ui.exec_()

        # Verify that the wizard returned the expected value.
        self.assertEqual(rc, QDialog.Accepted)

    def test_cancel(self):
        """ Test Wizard Cancel button. """

        model = Model()
        view = Wizard(WizardPage(HBox()), id='Wizard.cancel')
        ui = view(model=model)

        robot = Robot()
        robot.record('Wizard.cancel', 'click', QWizard.CancelButton)
        robot.play(after=0)

        rc = ui.exec_()

        # Verify that the wizard returned the expected value.
        self.assertEqual(rc, QDialog.Rejected)


if __name__ == '__main__':
    unittest.main()
